using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace zadatak1 {
    public partial class Notepad : Form {
        private string trenutniFajl = "", dragDropFile = "";
        private bool drop = false;

        public Notepad() {
            InitializeComponent();
        }

        private void textBox1_TextChanged(object sender, EventArgs e) {
            statusStrip1.Items.Clear();
            statusStrip1.Items.Add("TextChanged");
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e) {
            timer1.Stop();
            statusStrip1.Items.Clear();
        }

        private void toolStripButtonOpen_Click(object sender, EventArgs e) {
            openFileDialog1.ShowDialog();
        }

        private void toolStripButtonSave_Click(object sender, EventArgs e) {
            if (trenutniFajl.Length == 0) saveFileDialog1.ShowDialog();
            else {
                StreamWriter writer = new StreamWriter(trenutniFajl);
                writer.Write(textBox1.Text);
                writer.Close();
            }
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e) {
            StreamReader reader = new StreamReader(trenutniFajl = openFileDialog1.FileName);
            textBox1.Text = reader.ReadToEnd();
            reader.Close();
        }

        private void saveFileDialog1_FileOk(object sender, CancelEventArgs e) {
            StreamWriter writer = new StreamWriter(trenutniFajl = saveFileDialog1.FileName);
            writer.Write(textBox1.Text);
            writer.Close();
        }

        private void toolStripButtonNew_Click(object sender, EventArgs e) {
            trenutniFajl = "";
            textBox1.Clear();
        }

        private void toolStripButtonCopy_Click(object sender, EventArgs e) {
            textBox1.Copy();
        }

        private void toolStripButtonPaste_Click(object sender, EventArgs e) {
            textBox1.Paste();
        }

        private void toolStripButtonUndo_Click(object sender, EventArgs e) {
            textBox1.Undo();
        }

        private void toolStripButtonCut_Click(object sender, EventArgs e) {
            textBox1.Cut();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e) {
            Dispose();
        }

        private void Notepad_KeyDown(object sender, KeyEventArgs e) {
            if (e.Control) {
                switch (e.KeyCode) {
                    case (Keys.C): textBox1.Copy(); break;
                    case (Keys.V): textBox1.Paste(); break;
                    case (Keys.X): textBox1.Cut(); break;
                    case (Keys.Z): textBox1.Undo(); break;
                }
            }
        }

        private void textBox1_DragEnter(object sender, DragEventArgs e) {
            dragDropFile = "";
            String[] ss = (String[])e.Data.GetData("FileName");
            foreach (String s in ss) dragDropFile += s;
            drop = true;
        }

        private void textBox1_DragLeave(object sender, EventArgs e) {
            drop = false; dragDropFile = "";
        }

        private void textBox1_MouseEnter(object sender, EventArgs e) {
            if (drop) {
                StreamReader reader = new StreamReader(trenutniFajl = dragDropFile);
                textBox1.Text = reader.ReadToEnd();
                reader.Close();
                drop = false; dragDropFile = "";
            }
        }
    }
}